import React, { useContext } from 'react';
import { DComposeContext } from '../compose';
import { DFormContext } from '../form';
export function DBaseDesign(props) {
    const { children, dCompose, dFormControl } = props;
    const composeContext = useContext(DComposeContext);
    const formContext = useContext(DFormContext);
    const supportCompose = composeContext && dCompose;
    const supportForm = formContext && dFormControl;
    let dataAttrs = {};
    if (supportCompose) {
        dataAttrs = Object.assign(dataAttrs, {
            'data-compose-support': true,
            'data-compose-support-active': dCompose.active,
            'data-compose-support-disabled': dCompose.disabled,
        });
    }
    if (supportForm) {
        dataAttrs = Object.assign(dataAttrs, dFormControl.wrapperAttrs);
    }
    return React.cloneElement(children, Object.assign(Object.assign({}, children.props), dataAttrs));
}
//# sourceMappingURL=BaseDesign.js.map