var __rest = (this && this.__rest) || function (s, e) {
    var t = {};
    for (var p in s) if (Object.prototype.hasOwnProperty.call(s, p) && e.indexOf(p) < 0)
        t[p] = s[p];
    if (s != null && typeof Object.getOwnPropertySymbols === "function")
        for (var i = 0, p = Object.getOwnPropertySymbols(s); i < p.length; i++) {
            if (e.indexOf(p[i]) < 0 && Object.prototype.propertyIsEnumerable.call(s, p[i]))
                t[p[i]] = s[p[i]];
        }
    return t;
};
import { jsx as _jsx } from "react/jsx-runtime";
import { useRef } from 'react';
import { DTransition } from './Transition';
export function DCollapseTransition(props) {
    const { children, dSize, dHorizontal = false, dStyles, onEnterRendered } = props, restProps = __rest(props, ["children", "dSize", "dHorizontal", "dStyles", "onEnterRendered"]);
    const dataRef = useRef({
        width: 0,
        height: 0,
    });
    const ref = useRef(null);
    return (_jsx(DTransition, Object.assign({}, restProps, { onEnterRendered: () => {
            onEnterRendered === null || onEnterRendered === void 0 ? void 0 : onEnterRendered();
            if (ref.current) {
                const cssText = ref.current.style.cssText;
                if (dHorizontal) {
                    ref.current.style.width = '';
                    ref.current.style.paddingLeft = '';
                    ref.current.style.paddingRight = '';
                    ref.current.style.marginLeft = '';
                    ref.current.style.marginRight = '';
                    const { width } = ref.current.getBoundingClientRect();
                    dataRef.current.width = width;
                }
                else {
                    ref.current.style.height = '';
                    ref.current.style.paddingTop = '';
                    ref.current.style.paddingBottom = '';
                    ref.current.style.marginTop = '';
                    ref.current.style.marginBottom = '';
                    const { height } = ref.current.getBoundingClientRect();
                    dataRef.current.height = height;
                }
                ref.current.style.cssText = cssText;
            }
        } }, { children: (state) => {
            const transitionStyle = Object.assign({}, dStyles[state]);
            switch (state) {
                case 'enter':
                    Object.assign(transitionStyle, {
                        [dHorizontal ? 'width' : 'height']: dSize,
                        overflow: 'hidden',
                    }, dHorizontal
                        ? {
                            paddingLeft: 0,
                            paddingRight: 0,
                            marginLeft: 0,
                            marginRight: 0,
                        }
                        : {
                            paddingTop: 0,
                            paddingBottom: 0,
                            marginTop: 0,
                            marginBottom: 0,
                        });
                    break;
                case 'entering':
                    Object.assign(transitionStyle, {
                        [dHorizontal ? 'width' : 'height']: dataRef.current[dHorizontal ? 'width' : 'height'],
                        overflow: 'hidden',
                    });
                    break;
                case 'leave':
                    if (ref.current) {
                        const { width, height } = ref.current.getBoundingClientRect();
                        dataRef.current.width = width;
                        dataRef.current.height = height;
                    }
                    Object.assign(transitionStyle, {
                        [dHorizontal ? 'width' : 'height']: dataRef.current[dHorizontal ? 'width' : 'height'],
                        overflow: 'hidden',
                    });
                    break;
                case 'leaving':
                    Object.assign(transitionStyle, {
                        [dHorizontal ? 'width' : 'height']: dSize,
                        overflow: 'hidden',
                    }, dHorizontal
                        ? {
                            paddingLeft: 0,
                            paddingRight: 0,
                            marginLeft: 0,
                            marginRight: 0,
                        }
                        : {
                            paddingTop: 0,
                            paddingBottom: 0,
                            marginTop: 0,
                            marginBottom: 0,
                        });
                    break;
                case 'leaved':
                    Object.assign(transitionStyle, {
                        [dHorizontal ? 'width' : 'height']: dSize,
                        overflow: 'hidden',
                    });
                    break;
                default:
                    break;
            }
            return children(ref, transitionStyle, state);
        } })));
}
//# sourceMappingURL=CollapseTransition.js.map