var __rest = (this && this.__rest) || function (s, e) {
    var t = {};
    for (var p in s) if (Object.prototype.hasOwnProperty.call(s, p) && e.indexOf(p) < 0)
        t[p] = s[p];
    if (s != null && typeof Object.getOwnPropertySymbols === "function")
        for (var i = 0, p = Object.getOwnPropertySymbols(s); i < p.length; i++) {
            if (e.indexOf(p[i]) < 0 && Object.prototype.propertyIsEnumerable.call(s, p[i]))
                t[p[i]] = s[p[i]];
        }
    return t;
};
import { jsx as _jsx } from "react/jsx-runtime";
import { isNumber, isObject } from 'lodash';
import { getClassName } from '@react-devui/utils';
import { usePrefixConfig, useComponentConfig, useGridConfig, useContextRequired } from '../../hooks';
import { registerComponentMate } from '../../utils';
import { DRowContext } from './Row';
const { COMPONENT_NAME } = registerComponentMate({ COMPONENT_NAME: 'DCol' });
export function DCol(props) {
    const _a = useComponentConfig(COMPONENT_NAME, props), { children, dSpan, dResponsiveProps } = _a, restProps = __rest(_a, ["children", "dSpan", "dResponsiveProps"]);
    //#region Context
    const dPrefix = usePrefixConfig();
    const { dColNum } = useGridConfig();
    const { gMediaMatch, gSpace } = useContextRequired(DRowContext);
    //#endregion
    const [span, responsiveProps] = (() => {
        let span = dSpan;
        let responsiveProps = undefined;
        if (dResponsiveProps) {
            for (const breakpoint of gMediaMatch) {
                if (breakpoint in dResponsiveProps) {
                    const data = dResponsiveProps[breakpoint];
                    if (isObject(data)) {
                        responsiveProps = Object.assign({}, data);
                        span = responsiveProps.dSpan;
                        delete responsiveProps.dSpan;
                    }
                    else {
                        span = data;
                    }
                    break;
                }
            }
        }
        return [span, responsiveProps];
    })();
    return dSpan === 0 ? null : (_jsx("div", Object.assign({}, restProps, responsiveProps, { className: getClassName(restProps.className, responsiveProps === null || responsiveProps === void 0 ? void 0 : responsiveProps.className, `${dPrefix}col`), style: Object.assign(Object.assign(Object.assign({}, restProps.style), responsiveProps === null || responsiveProps === void 0 ? void 0 : responsiveProps.style), { width: isNumber(span) ? `calc(100% / ${dColNum} * ${span})` : undefined, flexGrow: span === true ? 1 : undefined, paddingLeft: gSpace, paddingRight: gSpace }) }, { children: children })));
}
//# sourceMappingURL=Col.js.map