import React from 'react';
import { DModalFooter } from './ModalFooter';
import { DModalHeader } from './ModalHeader';
export interface DModalProps extends React.HTMLAttributes<HTMLDivElement> {
    dVisible: boolean;
    dWidth?: number | string;
    dTop?: number | string;
    dZIndex?: number | string;
    dMask?: boolean;
    dMaskClosable?: boolean;
    dEscClosable?: boolean;
    dType?: {
        type: 'success' | 'warning' | 'error' | 'info';
        title?: React.ReactNode;
        description?: React.ReactNode;
        icon?: React.ReactNode;
    };
    dHeader?: React.ReactElement | string;
    dFooter?: React.ReactElement;
    onVisibleChange?: (visible: boolean) => void;
    afterVisibleChange?: (visible: boolean) => void;
}
export declare const DModal: {
    (props: DModalProps): JSX.Element | null;
    Header: typeof DModalHeader;
    Footer: typeof DModalFooter;
};
