import type { DElementSelector } from '@react-devui/hooks/useElement';
import type { DPopupPlacement } from '@react-devui/utils/position';
import React from 'react';
import { DPopoverFooter } from './PopoverFooter';
import { DPopoverHeader } from './PopoverHeader';
export interface DPopoverRef {
    updatePosition: () => void;
}
export interface DPopoverProps extends Omit<React.HTMLAttributes<HTMLDivElement>, 'children'> {
    children: React.ReactElement;
    dVisible?: boolean;
    dTrigger?: 'hover' | 'click';
    dContainer?: DElementSelector | false;
    dPlacement?: DPopupPlacement;
    dEscClosable?: boolean;
    dArrow?: boolean;
    dModal?: boolean;
    dDisabled?: boolean;
    dDistance?: number;
    dMouseEnterDelay?: number;
    dMouseLeaveDelay?: number;
    dZIndex?: number | string;
    dHeader?: React.ReactElement | string;
    dContent: React.ReactNode;
    dFooter?: React.ReactElement;
    onVisibleChange?: (visible: boolean) => void;
    afterVisibleChange?: (visible: boolean) => void;
}
declare function Popover(props: DPopoverProps, ref: React.ForwardedRef<DPopoverRef>): JSX.Element | null;
export declare const DPopover: {
    (props: DPopoverProps & React.RefAttributes<DPopoverRef>): ReturnType<typeof Popover>;
    Header: typeof DPopoverHeader;
    Footer: typeof DPopoverFooter;
};
export {};
