import { jsx as _jsx, jsxs as _jsxs } from "react/jsx-runtime";
import { useMemo } from 'react';
import { DIconContext } from '@react-devui/icons/Icon';
import { DConfigContext } from '../../hooks/d-config/contex';
import { dayjs } from '../dayjs';
import { Notification } from './Notification';
import { Toast } from './Toast';
const loadLocales = [];
export function DRoot(props) {
    var _a, _b, _c, _d;
    const { children, dContext } = props;
    const lang = (_b = (_a = dContext === null || dContext === void 0 ? void 0 : dContext.i18n) === null || _a === void 0 ? void 0 : _a.lang) !== null && _b !== void 0 ? _b : 'zh-Hant';
    if (!loadLocales.includes(lang)) {
        loadLocales.push(lang);
        switch (lang) {
            case 'en-US':
                dayjs.locale('en-US', require('dayjs/locale/en'));
                break;
            case 'zh-Hant':
                dayjs.locale('zh-Hant', require('dayjs/locale/zh'));
                break;
            default:
                break;
        }
    }
    const iconProps = (_c = dContext === null || dContext === void 0 ? void 0 : dContext.componentConfigs) === null || _c === void 0 ? void 0 : _c.DIcon;
    const prefix = (_d = dContext === null || dContext === void 0 ? void 0 : dContext.prefix) !== null && _d !== void 0 ? _d : 'd-';
    const iconContext = useMemo(() => ({
        props: iconProps,
        prefix,
        twoToneColor: (theme) => [
            theme ? `var(--${prefix}color-${theme})` : `var(--${prefix}text-color)`,
            theme ? `var(--${prefix}background-color-${theme})` : `rgb(var(--${prefix}text-color-rgb) / 10%)`,
        ],
    }), [iconProps, prefix]);
    return (_jsx(DConfigContext.Provider, Object.assign({ value: dContext }, { children: _jsxs(DIconContext.Provider, Object.assign({ value: iconContext }, { children: [children, _jsx(Notification, {}), _jsx(Toast, {})] })) })));
}
//# sourceMappingURL=Root.js.map