var __rest = (this && this.__rest) || function (s, e) {
    var t = {};
    for (var p in s) if (Object.prototype.hasOwnProperty.call(s, p) && e.indexOf(p) < 0)
        t[p] = s[p];
    if (s != null && typeof Object.getOwnPropertySymbols === "function")
        for (var i = 0, p = Object.getOwnPropertySymbols(s); i < p.length; i++) {
            if (e.indexOf(p[i]) < 0 && Object.prototype.propertyIsEnumerable.call(s, p[i]))
                t[p[i]] = s[p[i]];
        }
    return t;
};
import { jsx as _jsx, jsxs as _jsxs } from "react/jsx-runtime";
import { isNumber, isUndefined } from 'lodash';
import { useEffect, useRef } from 'react';
import { useAsync, useForceUpdate } from '@react-devui/hooks';
import { checkNodeExist, getClassName } from '@react-devui/utils';
import { usePrefixConfig, useComponentConfig } from '../../hooks';
import { registerComponentMate, TTANSITION_DURING_BASE } from '../../utils';
import { DTransition } from '../_transition';
const { COMPONENT_NAME } = registerComponentMate({ COMPONENT_NAME: 'DSpinner' });
export function DSpinner(props) {
    const _a = useComponentConfig(COMPONENT_NAME, props), { children, dVisible = true, dText, dDelay, dSize = '28px', afterVisibleChange } = _a, restProps = __rest(_a, ["children", "dVisible", "dText", "dDelay", "dSize", "afterVisibleChange"]);
    //#region Context
    const dPrefix = usePrefixConfig();
    //#endregion
    //#region Ref
    const spinnerRef = useRef(null);
    const containerRef = useRef(null);
    //#endregion
    const asyncCapture = useAsync();
    const forceUpdate = useForceUpdate();
    const delayVisible = useRef(false);
    if (dVisible === false) {
        delayVisible.current = false;
    }
    const visible = isUndefined(dDelay) ? dVisible : delayVisible.current;
    const transitionStyles = {
        enter: { opacity: 0 },
        entering: {
            transition: ['opacity'].map((attr) => `${attr} ${TTANSITION_DURING_BASE}ms linear`).join(', '),
        },
        leaving: {
            opacity: 0,
            transition: ['opacity'].map((attr) => `${attr} ${TTANSITION_DURING_BASE}ms linear`).join(', '),
        },
        leaved: { display: 'none' },
    };
    useEffect(() => {
        if (isNumber(dDelay) && dVisible) {
            const [asyncGroup, asyncId] = asyncCapture.createGroup();
            asyncGroup.setTimeout(() => {
                delayVisible.current = true;
                forceUpdate();
            }, dDelay);
            return () => {
                asyncCapture.deleteGroup(asyncId);
            };
        }
    }, [asyncCapture, dDelay, dVisible, forceUpdate]);
    return (_jsx(DTransition, Object.assign({ dIn: visible, dDuring: TTANSITION_DURING_BASE, onEnterRendered: () => {
            if (spinnerRef.current && containerRef.current) {
                containerRef.current.style.top = `${(spinnerRef.current.clientHeight - containerRef.current.clientHeight) / 2}px`;
            }
        }, afterEnter: () => {
            afterVisibleChange === null || afterVisibleChange === void 0 ? void 0 : afterVisibleChange(true);
        }, afterLeave: () => {
            afterVisibleChange === null || afterVisibleChange === void 0 ? void 0 : afterVisibleChange(false);
        } }, { children: (state) => (_jsx("div", Object.assign({}, restProps, { ref: spinnerRef, className: getClassName(restProps.className, `${dPrefix}spinner`), style: Object.assign(Object.assign({}, restProps.style), transitionStyles[state]) }, { children: _jsxs("div", Object.assign({ ref: containerRef, className: `${dPrefix}spinner__container` }, { children: [_jsx("div", Object.assign({ className: `${dPrefix}spinner__icon`, style: { fontSize: dSize } }, { children: checkNodeExist(children) ? (children) : (_jsx("svg", Object.assign({ className: `${dPrefix}spinner__spinner`, width: "1em", height: "1em", viewBox: "0 0 50 50" }, { children: _jsx("circle", { cx: "25", cy: "25", r: "21", fill: "none", stroke: "currentColor", strokeWidth: "4", strokeLinecap: "round" }) }))) })), checkNodeExist(dText) && _jsx("div", Object.assign({ className: `${dPrefix}spinner__text` }, { children: dText }))] })) }))) })));
}
//# sourceMappingURL=Spinner.js.map