var __rest = (this && this.__rest) || function (s, e) {
    var t = {};
    for (var p in s) if (Object.prototype.hasOwnProperty.call(s, p) && e.indexOf(p) < 0)
        t[p] = s[p];
    if (s != null && typeof Object.getOwnPropertySymbols === "function")
        for (var i = 0, p = Object.getOwnPropertySymbols(s); i < p.length; i++) {
            if (e.indexOf(p[i]) < 0 && Object.prototype.propertyIsEnumerable.call(s, p[i]))
                t[p[i]] = s[p[i]];
        }
    return t;
};
import { jsx as _jsx, jsxs as _jsxs } from "react/jsx-runtime";
import { useState } from 'react';
import { LoadingOutlined } from '@react-devui/icons';
import { checkNodeExist, getClassName } from '@react-devui/utils';
import { usePrefixConfig, useComponentConfig, useGeneralContext, useDValue } from '../../hooks';
import { registerComponentMate } from '../../utils';
import { DBaseInput } from '../_base-input';
import { DTransition } from '../_transition';
import { useFormControl } from '../form';
const TTANSITION_DURING = 133;
const { COMPONENT_NAME } = registerComponentMate({ COMPONENT_NAME: 'DSwitch' });
export function DSwitch(props) {
    const _a = useComponentConfig(COMPONENT_NAME, props), { children, dFormControl, dModel, dLabelPlacement = 'right', dStateContent, dLoading = false, dDisabled = false, dInputProps, dInputRef, onModelChange } = _a, restProps = __rest(_a, ["children", "dFormControl", "dModel", "dLabelPlacement", "dStateContent", "dLoading", "dDisabled", "dInputProps", "dInputRef", "onModelChange"]);
    //#region Context
    const dPrefix = usePrefixConfig();
    const { gDisabled } = useGeneralContext();
    //#endregion
    const [isFocus, setIsFocus] = useState(false);
    const formControlInject = useFormControl(dFormControl);
    const [checked, changeChecked] = useDValue(false, dModel, onModelChange, undefined, formControlInject);
    const disabled = dDisabled || gDisabled || (dFormControl === null || dFormControl === void 0 ? void 0 : dFormControl.control.disabled);
    const transitionStyles = {
        enter: { left: 2 },
        entering: {
            left: 'calc(100% - 20px)',
            transition: ['width', 'padding', 'margin', 'left'].map((attr) => `${attr} ${TTANSITION_DURING}ms linear`).join(', '),
        },
        entered: { right: 2 },
        leave: { right: 2 },
        leaving: {
            right: 'calc(100% - 20px)',
            transition: ['width', 'padding', 'margin', 'right'].map((attr) => `${attr} ${TTANSITION_DURING}ms linear`).join(', '),
        },
        leaved: { left: 2 },
    };
    return (_jsxs("label", Object.assign({}, restProps, { className: getClassName(restProps.className, `${dPrefix}switch`, {
            [`${dPrefix}switch--label-left`]: dLabelPlacement === 'left',
            'is-checked': checked,
            'is-disabled': disabled,
            'is-loading': dLoading,
        }) }, { children: [_jsxs("div", Object.assign({ className: `${dPrefix}switch__state-container` }, { children: [dStateContent && (_jsx("div", Object.assign({ className: getClassName(`${dPrefix}switch__state-content`, `${dPrefix}switch__state-content--left`), style: { opacity: checked ? 1 : 0 } }, { children: dStateContent[0] }))), dStateContent && (_jsx("div", Object.assign({ className: `${dPrefix}switch__state-content`, style: { opacity: checked ? 0 : 1 } }, { children: dStateContent[1] }))), _jsx(DBaseInput, Object.assign({}, dInputProps, { ref: dInputRef, className: getClassName(dInputProps === null || dInputProps === void 0 ? void 0 : dInputProps.className, `${dPrefix}switch__input`), type: "checkbox", disabled: disabled || dLoading, role: "switch", "aria-checked": checked, onChange: (e) => {
                            var _a;
                            (_a = dInputProps === null || dInputProps === void 0 ? void 0 : dInputProps.onChange) === null || _a === void 0 ? void 0 : _a.call(dInputProps, e);
                            changeChecked(!checked);
                        }, onFocus: (e) => {
                            var _a;
                            (_a = dInputProps === null || dInputProps === void 0 ? void 0 : dInputProps.onFocus) === null || _a === void 0 ? void 0 : _a.call(dInputProps, e);
                            setIsFocus(true);
                        }, onBlur: (e) => {
                            var _a;
                            (_a = dInputProps === null || dInputProps === void 0 ? void 0 : dInputProps.onBlur) === null || _a === void 0 ? void 0 : _a.call(dInputProps, e);
                            setIsFocus(false);
                        }, dFormControl: dFormControl })), _jsx(DTransition, Object.assign({ dIn: checked, dDuring: TTANSITION_DURING }, { children: (state) => (_jsx("div", Object.assign({ className: getClassName(`${dPrefix}switch__state-dot`, {
                                'is-focus': isFocus,
                            }), style: transitionStyles[state] }, { children: dLoading && _jsx(LoadingOutlined, { dSpin: true }) }))) }))] })), checkNodeExist(children) && _jsx("div", Object.assign({ className: `${dPrefix}switch__label` }, { children: children }))] })));
}
//# sourceMappingURL=Switch.js.map