var __rest = (this && this.__rest) || function (s, e) {
    var t = {};
    for (var p in s) if (Object.prototype.hasOwnProperty.call(s, p) && e.indexOf(p) < 0)
        t[p] = s[p];
    if (s != null && typeof Object.getOwnPropertySymbols === "function")
        for (var i = 0, p = Object.getOwnPropertySymbols(s); i < p.length; i++) {
            if (e.indexOf(p[i]) < 0 && Object.prototype.propertyIsEnumerable.call(s, p[i]))
                t[p[i]] = s[p[i]];
        }
    return t;
};
import { createElement as _createElement } from "react";
import { jsx as _jsx, jsxs as _jsxs } from "react/jsx-runtime";
import { isUndefined } from 'lodash';
import { useMemo, useRef, useEffect } from 'react';
import { useEventCallback } from '@react-devui/hooks';
import { CaretRightOutlined, LoadingOutlined, MinusSquareOutlined, PlusSquareOutlined } from '@react-devui/icons';
import { getClassName } from '@react-devui/utils';
import { usePrefixConfig, useTranslation } from '../../hooks';
import { TTANSITION_DURING_BASE } from '../../utils';
import { DCollapseTransition } from '../_transition';
import { DCheckbox } from '../checkbox';
import { DVirtualScroll } from '../virtual-scroll';
export function DPanel(props) {
    const { dGetGroupId, dGetItemId, dList, dExpandIds, dHeight, dPadding, dFocusItem, dCustomItem, dShowLine = false, dMultiple, dFocusVisible, onClickItem, onFocusChange, onExpandChange, onKeyDown$ } = props, restProps = __rest(props, ["dGetGroupId", "dGetItemId", "dList", "dExpandIds", "dHeight", "dPadding", "dFocusItem", "dCustomItem", "dShowLine", "dMultiple", "dFocusVisible", "onClickItem", "onFocusChange", "onExpandChange", "onKeyDown$"]);
    //#region Context
    const dPrefix = usePrefixConfig();
    //#endregion
    //#region Ref
    const dVSRef = useRef(null);
    //#endregion
    const [t] = useTranslation();
    const handleKeyDown = useEventCallback((key) => {
        var _a, _b, _c, _d, _e, _f;
        const focusNode = (node) => {
            if (node) {
                onFocusChange(node);
            }
        };
        if (dFocusItem) {
            const isExpand = dExpandIds.has(dFocusItem.id);
            switch (key) {
                case 'next':
                    focusNode((_a = dVSRef.current) === null || _a === void 0 ? void 0 : _a.scrollByStep(1));
                    break;
                case 'prev':
                    focusNode((_b = dVSRef.current) === null || _b === void 0 ? void 0 : _b.scrollByStep(-1));
                    break;
                case 'first':
                    focusNode((_c = dVSRef.current) === null || _c === void 0 ? void 0 : _c.scrollToStart());
                    break;
                case 'last':
                    focusNode((_d = dVSRef.current) === null || _d === void 0 ? void 0 : _d.scrollToEnd());
                    break;
                case 'prev-level':
                    if (!dFocusItem.isLeaf && isExpand) {
                        onExpandChange(dFocusItem);
                    }
                    else if (dFocusItem.parent) {
                        (_e = dVSRef.current) === null || _e === void 0 ? void 0 : _e.scrollToItem(dFocusItem.parent);
                        focusNode(dFocusItem.parent);
                    }
                    break;
                case 'next-level':
                    if (!dFocusItem.isLeaf) {
                        if (isExpand) {
                            focusNode((_f = dVSRef.current) === null || _f === void 0 ? void 0 : _f.scrollByStep(1));
                        }
                        else {
                            onExpandChange(dFocusItem);
                        }
                    }
                    break;
                case 'click':
                    onClickItem(dFocusItem);
                    break;
                default:
                    break;
            }
        }
    });
    useEffect(() => {
        const ob = onKeyDown$.subscribe({
            next: (key) => {
                handleKeyDown(key);
            },
        });
        return () => {
            ob.unsubscribe();
        };
    }, [handleKeyDown, onKeyDown$]);
    const preventBlur = (e) => {
        if (e.button === 0) {
            e.preventDefault();
        }
    };
    const vsPerformance = useMemo(() => ({
        dList,
        dExpands: dExpandIds,
        dItemSize: 32,
        dItemNested: (item) => ({
            list: item.children,
            emptySize: 32,
            asItem: true,
        }),
        dItemKey: (item) => item.id,
        dFocusable: (item) => item.enabled,
    }), [dExpandIds, dList]);
    return (_jsx(DVirtualScroll, Object.assign({}, vsPerformance, { ref: dVSRef, dFillNode: _jsx("li", {}), dItemRender: (item, index, { iARIA, iChildren }) => {
            if (item.children) {
                const isExpand = dExpandIds.has(item.id);
                return (_createElement("li", Object.assign({}, iARIA, { key: item.id, className: getClassName(`${dPrefix}tree__option-group`, {
                        [`${dPrefix}tree__option-group--root`]: iARIA['aria-level'] === 1,
                    }), role: "treeitem", "aria-expanded": isExpand, "aria-selected": item.checked, "aria-disabled": item.disabled }),
                    _jsxs("div", Object.assign({ id: dGetGroupId(item.id), className: getClassName(`${dPrefix}tree__option`, {
                            [`${dPrefix}tree__option--root`]: iARIA['aria-level'] === 1,
                            [`${dPrefix}tree__option--first`]: index === 0,
                            'is-selected': !dMultiple && item.checked,
                            'is-disabled': item.disabled,
                        }), title: item.origin.label, onClick: () => {
                            onFocusChange(item);
                            onClickItem(item);
                        } }, { children: [dFocusVisible && item.id === (dFocusItem === null || dFocusItem === void 0 ? void 0 : dFocusItem.id) && _jsx("div", { className: `${dPrefix}focus-outline` }), _jsx("div", Object.assign({ className: `${dPrefix}tree__option-icon`, onMouseDown: (e) => {
                                    preventBlur(e);
                                }, onMouseUp: (e) => {
                                    preventBlur(e);
                                }, onClick: (e) => {
                                    e.stopPropagation();
                                    onExpandChange(item);
                                } }, { children: item.origin.loading ? (_jsx(LoadingOutlined, { dSpin: true })) : dShowLine ? (isExpand ? (_jsx(MinusSquareOutlined, {})) : (_jsx(PlusSquareOutlined, {}))) : (_jsx(CaretRightOutlined, { className: `${dPrefix}tree__option-arrow`, dRotate: isExpand ? 90 : undefined })) })), dMultiple && (_jsx(DCheckbox, { dModel: item.checked, dDisabled: item.disabled, dIndeterminate: item.indeterminate, dInputProps: { tabIndex: -1 } })), _jsx("div", Object.assign({ className: `${dPrefix}tree__option-content` }, { children: dCustomItem ? dCustomItem(item.origin) : item.origin.label }))] })),
                    !item.origin.loading && (_jsx(DCollapseTransition, Object.assign({ dSize: 0, dIn: isExpand, dDuring: TTANSITION_DURING_BASE, dStyles: {
                            entering: {
                                transition: ['height', 'padding', 'margin'].map((attr) => `${attr} ${TTANSITION_DURING_BASE}ms ease-out`).join(', '),
                            },
                            leaving: {
                                transition: ['height', 'padding', 'margin'].map((attr) => `${attr} ${TTANSITION_DURING_BASE}ms ease-in`).join(', '),
                            },
                            leaved: { display: 'none' },
                        } }, { children: (collapseRef, collapseStyle) => (_jsx("ul", Object.assign({ ref: collapseRef, className: `${dPrefix}tree__option-group`, style: collapseStyle, role: "group", "aria-labelledby": dGetGroupId(item.id) }, { children: iChildren }))) })))));
            }
            return (_createElement("li", Object.assign({}, iARIA, { key: item.id, id: dGetItemId(item.id), className: getClassName(`${dPrefix}tree__option`, {
                    [`${dPrefix}tree__option--root`]: iARIA['aria-level'] === 1,
                    [`${dPrefix}tree__option--first`]: index === 0,
                    'is-selected': !dMultiple && item.checked,
                    'is-disabled': item.disabled,
                }), title: item.origin.label, role: "treeitem", "aria-selected": item.checked, "aria-disabled": item.disabled, onClick: () => {
                    onFocusChange(item);
                    onClickItem(item);
                } }),
                dFocusVisible && item.id === (dFocusItem === null || dFocusItem === void 0 ? void 0 : dFocusItem.id) && _jsx("div", { className: `${dPrefix}focus-outline` }),
                dMultiple && (_jsx(DCheckbox, { dModel: item.checked, dDisabled: item.disabled, dIndeterminate: item.indeterminate, dInputProps: { tabIndex: -1 } })),
                _jsx("div", Object.assign({ className: `${dPrefix}tree__option-content` }, { children: dCustomItem ? dCustomItem(item.origin) : item.origin.label }))));
        }, dFocusItem: dFocusItem, dSize: dHeight, dPadding: dPadding, dEmptyRender: () => (_jsx("li", Object.assign({ className: `${dPrefix}tree__empty` }, { children: _jsx("div", Object.assign({ className: `${dPrefix}tree__option-content` }, { children: t('No Data') })) }))) }, { children: ({ vsScrollRef, vsRender, vsOnScroll }) => {
            var _a, _b, _c, _d;
            return (
            // eslint-disable-next-line jsx-a11y/aria-activedescendant-has-tabindex
            _jsx("ul", Object.assign({}, restProps, { ref: vsScrollRef, className: getClassName(restProps.className, `${dPrefix}tree`, {
                    [`${dPrefix}tree--line`]: dShowLine,
                }), tabIndex: (_a = restProps.tabIndex) !== null && _a !== void 0 ? _a : -1, role: (_b = restProps.role) !== null && _b !== void 0 ? _b : 'tree', "aria-multiselectable": (_c = restProps['aria-multiselectable']) !== null && _c !== void 0 ? _c : dMultiple, "aria-activedescendant": (_d = restProps['aria-activedescendant']) !== null && _d !== void 0 ? _d : (isUndefined(dFocusItem) ? undefined : dGetItemId(dFocusItem.id)), onScroll: vsOnScroll }, { children: dList.length === 0 ? (_jsx("li", Object.assign({ className: `${dPrefix}tree__empty`, style: { marginLeft: 0 } }, { children: _jsx("div", Object.assign({ className: `${dPrefix}tree__option-content` }, { children: t('No Data') })) }))) : (vsRender) })));
        } })));
}
//# sourceMappingURL=Panel.js.map