import { useContext } from 'react';
import { DConfigContext } from './contex';
const BREAKPOINTS = new Map([
    ['xs', 0],
    ['sm', 576],
    ['md', 768],
    ['lg', 992],
    ['xl', 1200],
    ['xxl', 1400],
]);
export function useGridConfig() {
    var _a, _b, _c;
    const grid = (_a = useContext(DConfigContext)) === null || _a === void 0 ? void 0 : _a.grid;
    const breakpoints = (_b = grid === null || grid === void 0 ? void 0 : grid.breakpoints) !== null && _b !== void 0 ? _b : BREAKPOINTS;
    const colNum = (_c = grid === null || grid === void 0 ? void 0 : grid.colNum) !== null && _c !== void 0 ? _c : 12;
    return {
        dBreakpoints: breakpoints,
        dColNum: colNum,
    };
}
//# sourceMappingURL=useGridConfig.js.map