import { isNull, isUndefined } from 'lodash';
import { useContext } from 'react';
export function useContextRequired(Context) {
    const context = useContext(Context);
    if (isNull(context) || isUndefined(context)) {
        throw new Error('Context is required!');
    }
    return context;
}
//# sourceMappingURL=useContextRequired.js.map